summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rwxr-xr-xgettext-tools/tests/xgettext-c-1049
1 files changed, 49 insertions, 0 deletions
diff --git a/gettext-tools/tests/xgettext-c-10 b/gettext-tools/tests/xgettext-c-10
new file mode 100755
index 0000000..9c3d5e1
--- /dev/null
+++ b/gettext-tools/tests/xgettext-c-10
@@ -0,0 +1,49 @@
+#! /bin/sh
+
+# Test C support: extraction of contexts.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles xg-c-10.c"
+cat <<\EOF > xg-c-10.c
+// (KDE) The 1-argument i18n macro is a simple gettext without context.
+print (i18n ("help"));
+// (KDE) The 2-argument i18n macro has the context first.
+print (i18n ("Help", "about"));
+// (Qt) The 2-argument tr function has the context last.
+print (tr ("file"));
+print (tr ("open", "File"));
+EOF
+
+tmpfiles="$tmpfiles xg-c-10.po"
+: ${XGETTEXT=xgettext}
+${XGETTEXT} --omit-header --no-location \
+ --keyword=i18n:1 --keyword=i18n:1c,2 --keyword=tr:1 --keyword=tr:1,2c \
+ xg-c-10.c -d xg-c-10
+test $? = 0 || { rm -fr $tmpfiles; exit 1; }
+
+tmpfiles="$tmpfiles xg-c-10.ok"
+cat <<EOF > xg-c-10.ok
+msgid "help"
+msgstr ""
+
+msgctxt "Help"
+msgid "about"
+msgstr ""
+
+msgid "file"
+msgstr ""
+
+msgctxt "File"
+msgid "open"
+msgstr ""
+EOF
+
+: ${DIFF=diff}
+${DIFF} xg-c-10.ok xg-c-10.po
+result=$?
+
+rm -fr $tmpfiles
+
+exit $result